using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;
using NCMS;
using NCMS.Utils;
using UnityEngine;
using ReflectionUtility;
using HarmonyLib;
using System.Reflection;
using Newtonsoft.Json;

namespace SpaceBox
{
    class PlanetGenerator
    {

		public static int mapSizeX = 10;
		public static int mapSizeY = 10;
		public void Awake()
		{

		}

		public static bool setMapSize_Prefix(ref int pWidth, ref int pHeight)
		{

				pWidth = mapSizeX;
				pHeight = mapSizeY;

			return true;
		}

        private static void ClearBiomes()
        {
            BiomeLibrary.pool_biomes.Clear();
        }

        private static void LogAndClearBiomes()
        {

            Debug.Log("Current Biome Pool:");
            foreach (var biome in BiomeLibrary.pool_biomes)
            {
                Debug.Log(biome.ToString()); 
            }

            ClearBiomes();

            Debug.Log("Biome Pool After Clearing:");
            if (BiomeLibrary.pool_biomes.Count == 0)
            {
                Debug.Log("Biome pool is now empty.");
            }
            else
            {
                foreach (var biome in BiomeLibrary.pool_biomes)
                {
                    Debug.Log(biome.ToString()); 
                }
            }
        }

        public static void ChoosePlanetBiomes(string type)
        {

			Harmony harmony = new Harmony("tuxxego.worldbox.spaceindabox");

			MethodInfo original = AccessTools.Method(typeof(MapBox), "setMapSize");
			MethodInfo patch = AccessTools.Method(typeof(PlanetGenerator), "setMapSize_Prefix");
			harmony.Patch(original, new HarmonyMethod(patch));
			Debug.Log("Pre patch: MapBox.setMapSize");

				Config.current_map_template = "boring_plains";

            LogAndClearBiomes();

            switch (type.ToLower())
            {
                case "desert world":
                    Debug.Log("Desert World biome selected.");

            BiomeAsset DesertPlanet = new BiomeAsset();
            DesertPlanet.id = "biome_DesertPlanet";
			      DesertPlanet.tile_low = "DesertPlanet_low";
			      DesertPlanet.tile_high = "DesertPlanet_high";
			      DesertPlanet.grow_strength = 10;
			      DesertPlanet.spread_biome = true;
			      DesertPlanet.generator_pool_amount = 8;
            DesertPlanet.grow_vegetation_auto = false;
			      DesertPlanet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      DesertPlanet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      DesertPlanet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        DesertPlanet.addUnit(SA.frog, 1);
		        DesertPlanet.addUnit(SA.sheep, 1);
		        DesertPlanet.addMineral(SB.mineral_stone, 5);
		        DesertPlanet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(DesertPlanet);
            AssetManager.biome_library.addBiomeToPool(DesertPlanet);

			break;

    case "icy":

            BiomeAsset IcePlanet = new BiomeAsset();
            IcePlanet.id = "biome_IcePlanet";
			      IcePlanet.tile_low = "permafrost_low";
			      IcePlanet.tile_high = "permafrost_high";
			      IcePlanet.grow_strength = 10;
			      IcePlanet.spread_biome = true;
			      IcePlanet.generator_pool_amount = 8;
            IcePlanet.grow_vegetation_auto = false;
			      IcePlanet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      IcePlanet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      IcePlanet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        IcePlanet.addUnit(SA.frog, 1);
		        IcePlanet.addUnit(SA.sheep, 1);
		        IcePlanet.addMineral(SB.mineral_stone, 5);
		        IcePlanet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(IcePlanet);
            AssetManager.biome_library.addBiomeToPool(IcePlanet);

            BiomeAsset IcePlanet1 = new BiomeAsset();
            IcePlanet1.id = "biome_IcePlanet1";
			      IcePlanet1.tile_low = "frozen_low";
			      IcePlanet1.tile_high = "frozen_high";
			      IcePlanet1.grow_strength = 10;
			      IcePlanet1.spread_biome = true;
			      IcePlanet1.generator_pool_amount = 8;
            IcePlanet1.grow_vegetation_auto = false;
			      IcePlanet1.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      IcePlanet1.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      IcePlanet1.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        IcePlanet1.addUnit(SA.frog, 1);
		        IcePlanet1.addUnit(SA.sheep, 1);
		        IcePlanet1.addMineral(SB.mineral_stone, 5);
		        IcePlanet1.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(IcePlanet1);
            AssetManager.biome_library.addBiomeToPool(IcePlanet1);
break;			

    case "oceanic":

				Config.current_map_template = "empty";
break;
    case "mechanical world":

	            BiomeAsset RobotPlanet = new BiomeAsset();
            RobotPlanet.id = "biome_RobotPlanet";
			      RobotPlanet.tile_low = "cybertile_low";
			      RobotPlanet.tile_high = "cybertile_high";
			      RobotPlanet.grow_strength = 10;
			      RobotPlanet.spread_biome = true;
			      RobotPlanet.generator_pool_amount = 8;
            RobotPlanet.grow_vegetation_auto = false;
			      RobotPlanet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      RobotPlanet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      RobotPlanet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        RobotPlanet.addUnit(SA.frog, 1);
		        RobotPlanet.addUnit(SA.sheep, 1);
		        RobotPlanet.addMineral(SB.mineral_stone, 5);
		        RobotPlanet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(RobotPlanet);
            AssetManager.biome_library.addBiomeToPool(RobotPlanet);
			break;			

    case "lava world":

            BiomeAsset LavaPlanet = new BiomeAsset();
            LavaPlanet.id = "biome_LavaPlanet";
			      LavaPlanet.tile_low = "infernal_low";
			      LavaPlanet.tile_high = "infernal_high";
			      LavaPlanet.grow_strength = 10;
			      LavaPlanet.spread_biome = true;
			      LavaPlanet.generator_pool_amount = 8;
            LavaPlanet.grow_vegetation_auto = false;
			      LavaPlanet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      LavaPlanet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      LavaPlanet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        LavaPlanet.addUnit(SA.frog, 1);
		        LavaPlanet.addUnit(SA.sheep, 1);
		        LavaPlanet.addMineral(SB.mineral_stone, 5);
		        LavaPlanet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(LavaPlanet);
            AssetManager.biome_library.addBiomeToPool(LavaPlanet);

			break;
    case "crystal world":

            BiomeAsset CrystalPlanet = new BiomeAsset();
            CrystalPlanet.id = "biome_CrystalPlanet";
			      CrystalPlanet.tile_low = "crystal_low";
			      CrystalPlanet.tile_high = "crystal_high";
			      CrystalPlanet.grow_strength = 10;
			      CrystalPlanet.spread_biome = true;
			      CrystalPlanet.generator_pool_amount = 8;
            CrystalPlanet.grow_vegetation_auto = false;
			      CrystalPlanet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      CrystalPlanet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      CrystalPlanet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        CrystalPlanet.addUnit(SA.frog, 1);
		        CrystalPlanet.addUnit(SA.sheep, 1);
		        CrystalPlanet.addMineral(SB.mineral_stone, 5);
		        CrystalPlanet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(CrystalPlanet);
            AssetManager.biome_library.addBiomeToPool(CrystalPlanet);
break;			

    case "swamp world":

            BiomeAsset SwampPlanet = new BiomeAsset();
            SwampPlanet.id = "biome_SwampPlanet";
			      SwampPlanet.tile_low = "swamp_low";
			      SwampPlanet.tile_high = "swamp_high";
			      SwampPlanet.grow_strength = 10;
			      SwampPlanet.spread_biome = true;
			      SwampPlanet.generator_pool_amount = 8;
            SwampPlanet.grow_vegetation_auto = false;
			      SwampPlanet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      SwampPlanet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      SwampPlanet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        SwampPlanet.addUnit(SA.frog, 1);
		        SwampPlanet.addUnit(SA.sheep, 1);
		        SwampPlanet.addMineral(SB.mineral_stone, 5);
		        SwampPlanet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(SwampPlanet);
            AssetManager.biome_library.addBiomeToPool(SwampPlanet);
break;			

    case "jungle world":

            BiomeAsset Jungle1Planet = new BiomeAsset();
            Jungle1Planet.id = "biome_Jungle1Planet";
			      Jungle1Planet.tile_low = "jungle_low";
			      Jungle1Planet.tile_high = "jungle_high";
			      Jungle1Planet.grow_strength = 10;
			      Jungle1Planet.spread_biome = true;
			      Jungle1Planet.generator_pool_amount = 20;
            Jungle1Planet.grow_vegetation_auto = true;
			      Jungle1Planet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      Jungle1Planet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      Jungle1Planet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        Jungle1Planet.addUnit(SA.frog, 1);
		        Jungle1Planet.addUnit(SA.sheep, 1);
		        Jungle1Planet.addMineral(SB.mineral_stone, 5);
		        Jungle1Planet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(Jungle1Planet);
            AssetManager.biome_library.addBiomeToPool(Jungle1Planet);

            BiomeAsset Jungle2Planet = new BiomeAsset();
            Jungle2Planet.id = "biome_Jungle2Planet";
			      Jungle2Planet.tile_low = "enchanted_low";
			      Jungle2Planet.tile_high = "enchanted_high";
			      Jungle2Planet.grow_strength = 10;
			      Jungle2Planet.spread_biome = true;
			      Jungle2Planet.generator_pool_amount = 8;
            Jungle2Planet.grow_vegetation_auto = true;
			      Jungle2Planet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      Jungle2Planet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      Jungle2Planet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        Jungle2Planet.addUnit(SA.frog, 1);
		        Jungle2Planet.addUnit(SA.sheep, 1);
		        Jungle2Planet.addMineral(SB.mineral_stone, 5);
		        Jungle2Planet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(Jungle2Planet);
            AssetManager.biome_library.addBiomeToPool(Jungle2Planet);

            BiomeAsset Jungle3Planet = new BiomeAsset();
            Jungle3Planet.id = "biome_Jungle3Planet";
			      Jungle3Planet.tile_low = "swamp_low";
			      Jungle3Planet.tile_high = "swamp_high";
			      Jungle3Planet.grow_strength = 10;
			      Jungle3Planet.spread_biome = true;
			      Jungle3Planet.generator_pool_amount = 8;
            Jungle3Planet.grow_vegetation_auto = true;
			      Jungle3Planet.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      Jungle3Planet.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      Jungle3Planet.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        Jungle3Planet.addUnit(SA.frog, 1);
		        Jungle3Planet.addUnit(SA.sheep, 1);
		        Jungle3Planet.addMineral(SB.mineral_stone, 5);
		        Jungle3Planet.addMineral(SB.mineral_metals, 3);
            AssetManager.biome_library.add(Jungle3Planet);
            AssetManager.biome_library.addBiomeToPool(Jungle3Planet);

break;			

                default:
                    Debug.Log("Space biome selected.");

            BiomeAsset Space = new BiomeAsset();
            Space.id = "biome_Space";
			      Space.tile_low = "Space_low";
			      Space.tile_high = "Space_high";
			      Space.grow_strength = 10;
			      Space.spread_biome = true;
			      Space.generator_pool_amount = 8;
			      Space.force_unit_skin_set = "mushroom";
            Space.grow_vegetation_auto = true;
			      Space.grow_type_selector_minerals = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomMineral);
			      Space.grow_type_selector_trees = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomTrees);
			      Space.grow_type_selector_plants = new GrowTypeSelector(TileActionLibrary.getGrowTypeRandomPlants);
		        Space.addUnit(SA.frog, 1);
		        Space.addUnit(SA.sheep, 1);
		        Space.addMineral(SB.mineral_stone, 5);
		        Space.addMineral(SB.mineral_metals, 3);
		        Space.addTree("Space_tree", 1);
		        Space.addPlant("Space", 1);
            AssetManager.biome_library.add(Space);
            AssetManager.biome_library.addBiomeToPool(Space);

            TopTileType Space_low = AssetManager.topTiles.clone("Space_low", ST.mushroom_low);
            Space_low.color = Toolbox.makeColor("#3b3aad", -1f);
            Space_low.setBiome("biome_Space");
		        Space_low.force_unit_skin_set = "enchanted";
			      Space_low.rank_type = TileRank.Low;
            Space_low.setDrawLayer(TileZIndexes.mushroom_low, null);

            Space_low.stepActionChance = 1437f;
            Space_low.fireChance = 0.02f;
            Space_low.food_resource = SR.mushrooms;
				    Space_low.biome_asset = Space;
            AssetManager.topTiles.add(Space_low);
            AssetManager.topTiles.loadSpritesForTile(Space_low);
            TopTileType Space_high = AssetManager.topTiles.clone("Space_high", ST.mushroom_high);
            Space_high.color = Toolbox.makeColor("#000c8d", -1f);
            Space_high.setBiome("biome_Space");
			      Space_high.rank_type = TileRank.High;
		        Space_high.force_unit_skin_set = "enchanted";
            Space_high.setDrawLayer(TileZIndexes.mushroom_high, null);

            Space_high.stepActionChance = 1437f;
            Space_high.fireChance = 0.02f;
            Space_high.food_resource = SR.mushrooms;
				    Space_high.biome_asset = Space;
            AssetManager.topTiles.add(Space_high);
            AssetManager.topTiles.loadSpritesForTile(Space_high);

                    break;
            }
        }
    }
}