//========= MODERNBOX 2.0 ============//
//
// Made by Tuxxego
//
//=============================================================================//
using System;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using NCMS;
using NCMS.Utils;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.EventSystems;
using UnityEngine.UI;
using ReflectionUtility;
using Assets.SimpleZip;

namespace SpaceBox
{
    class Buttonz
    {
        public static void init()
        {

            tab.createTab("Button Tab_SpaceBox", "Tab_SpaceBox", "SpaceBox", "Welcome to the Space age.", -150);
            loadButtons();
		}
		
	    private static void loadButtons()
        {
			
			PowersTab tab = getPowersTab("SpaceBox");
		

    GameObject largeImageObject = new GameObject("LargeImage");
    largeImageObject.transform.SetParent(tab.transform);
    largeImageObject.transform.localPosition = new Vector3(288, 18, 0);
    largeImageObject.transform.localScale = new Vector3(1, 1, 1);

    Image largeImage = largeImageObject.AddComponent<Image>();
    largeImage.sprite = Resources.Load<Sprite>("ui/Icons/SpaceBoxIconTab");

    RectTransform largeImageRectTransform = largeImageObject.GetComponent<RectTransform>();
    largeImageRectTransform.sizeDelta = new Vector2(200, 100);
    largeImageRectTransform.anchorMin = new Vector2(0.5f, 0.5f);
    largeImageRectTransform.anchorMax = new Vector2(0.5f, 0.5f);


    PowerButtons.CreateButton("galaxy", Resources.Load<Sprite>("ui/icons/Galaxy"), "Star Map", "View a map of everything.", new Vector2(72, 18), ButtonType.Click, tab.transform,
	openStarMap
	);

    PowerButtons.CreateButton("arrowleft", Resources.Load<Sprite>("ui/icons/Discowd"), "Discord", "Join the discord server for SpaceBox and ModernBox!", new Vector2(72, -18), ButtonType.Click, tab.transform, OpenDiscordServerLink
	);
	

		

		}
			


        
        public static bool Stuff_Drop(WorldTile pTile, GodPower pPower)
        {
            AssetManager.powers.CallMethod("spawnDrops", pTile, pPower);
            return true;
        }
		
  private static void OpenDiscordServerLink() {

    string discordServerLink = "https://discord.gg/tuxxego";


    Application.OpenURL(discordServerLink);
  }

  private static void openStarMap() {


		SpaceManager.EnableSpace();
         Debug.Log("SpaceBox: openStarMap has been called but the star map ain't actually fucking showing up. (ofc it isn't)");

  }
		

        // public static void action_worker(WorldTile pTile = null, string pPowerID = null)
        // {

            // MapBox.instance.getObjectsInChunks(pTile, 3, MapObjectType.Actor);
            // List<BaseSimObject> temp_objs = World.world.temp_map_objects;
            // for (int i = 0; i < temp_objs.Count; i++)
            // {
                // Actor pActor = (Actor)temp_objs[i];

                // if (!pActor.asset.unit || pActor.city == null || pActor.asset.baby)
                // {
                    // continue;
                // }
                // pActor.CallMethod("setProfession", UnitProfession.Unit, true);
                // var pAI = (AiSystemActor)Reflection.GetField(typeof(Actor), pActor, "ai");
                // pAI.setJob("joboy");
            // }
        // }
		


       public static Actor spawnUnit(WorldTile pTile, string pPowerID)
        {
            GodPower godPower = AssetManager.powers.get(pPowerID);
            MusicBox.playSound("event:/SFX/UNIQUE/SpawnWhoosh", (float)pTile.pos.x, (float)pTile.pos.y, false, false);
            if (godPower.id == SA.sheep && pTile.Type.lava)
            {
                AchievementLibrary.achievementSacrifice.check(null, null, null);
            }
            EffectsLibrary.spawn("fx_spawn", pTile, null, null, 0f, -1f, -1f);
            string text;
            if (godPower.actor_asset_ids.Count > 0)
            {
                text = godPower.actor_asset_ids.GetRandom<string>();
            }
            else
            {
                text = godPower.actor_asset_id;
            }
            Actor actor = World.world.units.spawnNewUnit(text, pTile, true, godPower.actorSpawnHeight);
            actor.addTrait("miracle_born", false);
            actor.data.age_overgrowth = 1;
            actor.data.had_child_timeout = 8.0;
            return actor;
        }
		
		
		public static void action_MOABClick(WorldTile pTile, string pPowerID)
	    {
          EffectsLibrary.spawnAtTileRandomScale("fx_explosion_huge", pTile, 0.4f, 0.6f);
          MapAction.damageWorld(pTile, 50, TerraformLibrary.czarBomba, null);
		      World.world.startShake(0.3f, 0.01f, 2f, true, true);
         // return true;
        }
		
		public static void action_CobaltClick(WorldTile pTile, string pPowerID)
	    {
          EffectsLibrary.spawnAtTileRandomScale("fx_explosion_huge", pTile, 0.2f, 0.3f);
          MapAction.damageWorld(pTile, 120, TerraformLibrary.czarBomba, null);
		      World.world.startShake(0.3f, 0.01f, 2f, true, true);
         // return true;
        }
		
		public static void action_UltronClick(WorldTile pTile, string pPowerID)
	    {
          EffectsLibrary.spawnAtTileRandomScale("fx_explosion_huge", pTile, 0.8f, 0.9f);
          MapAction.damageWorld(pTile, 100, TerraformLibrary.czarBomba, null);
		      World.world.startShake(0.3f, 0.01f, 2f, true, true);
         // return true;
        }
		    private static PowersTab getPowersTab(string id)
		    {
			  GameObject gameObject = GameObjects.FindEvenInactive("Tab_" + id);
			  return gameObject.GetComponent<PowersTab>();
			}
    }
}